

const SIZE: usize = 0x800000;
const SIZE_MASK: usize = SIZE - 1;

pub struct Seen {
    pub bitarr: Vec<u8>,
}

impl Seen {
    pub fn new() -> Seen {
        Seen {
            bitarr: vec![0; SIZE]
        }
    }

    fn fix(&self, ix: u64) -> (usize, u8) {
        let hi = (ix >> 3) & SIZE_MASK as u64;
        let lo = 1 << (ix & 0x7);
        (hi as usize, lo)
    }

    // TODO: Elide bounds checks
    pub fn add(&mut self, ix: u64) {
        let (hi, lo) = self.fix(ix);
        self.bitarr[hi] |= lo;
    }

    pub fn contains(&self, ix: u64) -> bool {
        let (hi, lo) = self.fix(ix);
        self.bitarr[hi] & lo != 0
    }
}